Package org.eclipse.m2m.atl.emftvm.util

## Class LazyList.InsertAtList<E>

- java.lang.Object
- - org.eclipse.m2m.atl.emftvm.util.LazyCollection<E>
  - - org.eclipse.m2m.atl.emftvm.util.LazyList<E>
    - - org.eclipse.m2m.atl.emftvm.util.LazyList.NonCachingList<E>
      - - org.eclipse.m2m.atl.emftvm.util.LazyList.AppendList<E>
        - - org.eclipse.m2m.atl.emftvm.util.LazyList.InsertAtList<E>

Type Parameters:
  `E` -

All Implemented Interfaces:
  `java.lang.Iterable<E>`, `java.util.Collection<E>`, `java.util.List<E>`, `org.eclipse.emf.common.util.EList<E>`

Enclosing class:
  LazyList<E>

    public static class LazyList.InsertAtList<E>
    extends LazyList.AppendList<E>

`LazyList` that inserts an element it a given index in the underlying collection. List index starts at 0.

### Nested Class Summary

Nested Classes
`class` `LazyList.InsertAtList.InsertAtIterator` Inserts an element into the underlying collection at the given index.
`class` `LazyList.InsertAtList.InsertAtListIterator` Inserts an element into the underlying collection at the given index.

### Nested classes/interfaces inherited from class org.eclipse.m2m.atl.emftvm.util.LazyList.AppendList

`LazyList.AppendList.AppendListIterator`

### Nested classes/interfaces inherited from class org.eclipse.m2m.atl.emftvm.util.LazyList

`LazyList.AppendList<E>, LazyList.CollectList<E>, LazyList.InsertAtList<E>, LazyList.IntegerRangeList, LazyList.LongRangeList, LazyList.NonCachingList<E>, LazyList.PrependList<E>, LazyList.ReverseList<E>, LazyList.SubList<E>, LazyList.UnionList<E>, LazyList.UnionListIterator`

### Nested classes/interfaces inherited from class org.eclipse.m2m.atl.emftvm.util.LazyCollection

`LazyCollection.AppendIterator, LazyCollection.CachingIterator, LazyCollection.CachingSetIterator, LazyCollection.CollectIterator<T>, LazyCollection.ExcludingIterator, LazyCollection.FilterIterator, LazyCollection.FlattenIterator, LazyCollection.FlattenSetIterator, LazyCollection.IntegerRangeListIterator, LazyCollection.IntersectionIterator, LazyCollection.IteratorToListIterator, LazyCollection.LongRangeListIterator, LazyCollection.ReadOnlyIterator<E>, LazyCollection.ReadOnlyListIterator<E>, LazyCollection.RejectIterator, LazyCollection.ReverseIterator, LazyCollection.ReverseListIterator, LazyCollection.SelectIterator, LazyCollection.SubListIterator, LazyCollection.SubListListIterator, LazyCollection.SubtractionIterator, LazyCollection.UnionIterator, LazyCollection.UnionSetIterator, LazyCollection.WrappedIterator, LazyCollection.WrappedListIterator`

### Field Summary

Fields
`protected int` `index`

### Fields inherited from class org.eclipse.m2m.atl.emftvm.util.LazyList.AppendList

`object`

### Fields inherited from class org.eclipse.m2m.atl.emftvm.util.LazyCollection

`cache, dataSource, occurrences`

### Constructor Summary

Constructors
`InsertAtList​(int index, E object, LazyList<E> dataSource)` Creates a new `LazyList.InsertAtList`.

### Method Summary

All Methods Instance Methods Concrete Methods
`E` `first()` Returns the first element in self.
`E` `get​(int index)`
`int` `indexOf​(java.lang.Object o)`
`java.util.Iterator<E>` `iterator()`
`E` `last()` Returns the last element in self.
`int` `lastIndexOf​(java.lang.Object o)`
`java.util.ListIterator<E>` `listIterator()`
`java.util.ListIterator<E>` `listIterator​(int index)`

### Methods inherited from class org.eclipse.m2m.atl.emftvm.util.LazyList.AppendList

`contains, count, isEmpty, size`

### Methods inherited from class org.eclipse.m2m.atl.emftvm.util.LazyList.NonCachingList

`createCache`

### Methods inherited from class org.eclipse.m2m.atl.emftvm.util.LazyList

`add, addAll, append, asSequence, asString, at, collect, equals, excluding, excludingAll, flatten, hashCode, including, including, includingAll, includingAll, includingRange, indexOf2, insertAt, lastIndexOf2, move, move, prepend, reject, remove, reverse, select, set, sortedBy, subList, subSequence, union, union`

### Methods inherited from class org.eclipse.m2m.atl.emftvm.util.LazyCollection

`add, addAll, any, appendElements, asBag, asOrderedSet, asSet, clear, containsAll, containsAny, excludes, excludesAll, exists, exists2, forAll, forAll2, includes, includesAll, isUnique, iterate, mappedBy, mappedBySingle, max, min, notEmpty, one, product, remove, removeAll, retainAll, sum, toArray, toArray, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.util.Collection

`parallelStream, removeIf, stream, toArray`

### Methods inherited from interface java.lang.Iterable

`forEach`

### Methods inherited from interface java.util.List

`add, addAll, clear, containsAll, remove, removeAll, replaceAll, retainAll, sort, spliterator, toArray, toArray`

### Field Detail

#### index

    protected final int index

### Constructor Detail

#### InsertAtList

    public InsertAtList​(int index,
                        E object,
                        LazyList<E> dataSource)

Creates a new `LazyList.InsertAtList`.

Parameters:
  `index` - the index at which to insert the element, starting from 0
  `object` - the element to insert
  `dataSource` - the underlying collection

### Method Detail

#### first

    public E first()

Returns the first element in self.

Overrides:
  `first` in class `LazyList<E>`
Returns:
  The first element in self.

#### last

    public E last()

Returns the last element in self.

Overrides:
  `last` in class `LazyList.AppendList<E>`
Returns:
  The last element in self.

#### get

    public E get​(int index)

Specified by:
  `get` in interface `java.util.List<E>`
Overrides:
  `get` in class `LazyList.AppendList<E>`

#### indexOf

    public int indexOf​(java.lang.Object o)

Specified by:
  `indexOf` in interface `java.util.List<E>`
Overrides:
  `indexOf` in class `LazyList.AppendList<E>`

#### lastIndexOf

    public int lastIndexOf​(java.lang.Object o)

Specified by:
  `lastIndexOf` in interface `java.util.List<E>`
Overrides:
  `lastIndexOf` in class `LazyList.AppendList<E>`

#### iterator

    public java.util.Iterator<E> iterator()

Specified by:
  `iterator` in interface `java.util.Collection<E>`
Specified by:
  `iterator` in interface `java.lang.Iterable<E>`
Specified by:
  `iterator` in interface `java.util.List<E>`
Overrides:
  `iterator` in class `LazyList.AppendList<E>`

#### listIterator

    public java.util.ListIterator<E> listIterator()

Specified by:
  `listIterator` in interface `java.util.List<E>`
Overrides:
  `listIterator` in class `LazyList.AppendList<E>`

#### listIterator

    public java.util.ListIterator<E> listIterator​(int index)

Specified by:
  `listIterator` in interface `java.util.List<E>`
Overrides:
  `listIterator` in class `LazyList.AppendList<E>`